Foreman - Feature #29144

Run Puma using systemd socket activation
02/24/2020 03:57 PM - Ewoud Kohl van Wijngaarden

Status: Closed
Priority: Normal
Assignee: Ewoud Kohl van Wijngaarden
Category: Packaging
Target version:
Difficulty: Fixed in Releases: 21.0
Triaged: Yes Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/7536,
https://github.com/theforeman/foreman-p
ackaging/pull/4894,
https://github.com/theforeman/foreman-p
ackaging/pull/4895,
https://github.com/theforeman/puppet-for
eman/pull/814,
https://github.com/theforeman/foreman-p
ackaging/pull/4901,
https://github.com/theforeman/puppet-for
eman/pull/816,
https://github.com/theforeman/puppet-for
eman/pull/817
Description

From https://github.com/puma/puma/blob/master/docs/systemd.md#socket-activation

systemd and puma also support socket activation, where systemd opens the listening socket(s) in advance and provides them
to the puma master process on startup. Among other advantages, this keeps listening sockets open across puma restarts and
achieves graceful restarts, including when upgraded puma, and is compatible with both clustered mode and application preload.

When using unix sockets, it should also increase security since only the webserver can connect to it.

Related issues:
Related to Foreman - Feature #32238: Bind systemd socket activation to IPv6

Closed

Associated revisions

Revision 3e388156 - 03/24/2020 12:27 PM - Ewoud Kohl van Wijngaarden

Fixes #29144 - Use systemd socket activation

From https://github.com/puma/puma/blob/master/docs/systemd.md#socket-activation

systemd and puma also support socket activation, where systemd opens the
listening socket(s) in advance and provides them to the puma master
process on startup. Among other advantages, this keeps listening sockets
open across puma restarts and achieves graceful restarts, including when
upgraded puma, and is compatible with both clustered mode and

application preload.

When using unix sockets, it should also increase security since only the
webserver can connect to it. This is not configured by default since the
webserver is not assumed to be present. However, it can be deployed via

overrides.

This also needs a packaging change for ExecStart. Currently RPM and Deb

packaging change this, but the wrappers break the passing on the socket.
https://github.com/puma/puma/blob/master/docs/systemd.md#socket-activation
https://github.com/puma/puma/blob/master/docs/systemd.md#socket-activation

Revision 5a8db7a8 - 03/24/2020 03:44 PM - Ewoud Kohl van Wijngaarden

Refs #29144 - Use systemd socket activation

This gives reliable service restarts since systemd keeps the socket
open.

Replacement of ExecStart is no longer needed since foreman core now
calls /usr/share/foreman/bin/rails which is already modified to use
/usr/bin/tfm-ruby.

It also correcs the macros to only execute on the subpackage. The
incorrect systemd_postun_with_restart (systemctl try-restart) is changed
to the appropriate systemd_post (systemctl preset).

The unused foreman.sysconfig is also dropped. This file was unused since
fb02554d5059e4817052de13d392320a6f4eb8ac.

Revision cd0965ff - 03/24/2020 05:10 PM - Ewoud Kohl van Wijngaarden

Refs #29144 - Use systemd socket activation

This gives reliable service restarts since systemd keeps the socket
open. bundle exec needs to be called with --keep-file-descriptors since
systemd passes these in. The replacement is changed since the service
now uses /usr/share/foreman/bin/rails which doesn't need replacing.

It also makes sure the service enable is called on the foreman-service
subpackage rather than the main package.

Revision 28111966 - 03/25/2020 05:09 PM - Ewoud Kohl van Wijngaarden

Refs #29144 - Use systemd socket activation

When using systemd socket activation, it's important that the
ListenSocket matches what Puma binds on. Otherwise it may fail. This
happens when is configured on [::]:3000 (dual stack) and Puma on
0.0.0.0:3000. Puma will then attempt to bind and fail because the port
is already in use.

The service bind is now made explicit because systemd's
ListenSocket=3000 binds on :: where Puma by default binds on
0.0.0.0:3000. This is IPv4-only, but is what was done prior to this as

well. Apache is configured dual stack and the recommended deployment.

Revision e642db1c - 03/26/2020 01:38 AM - Ewoud Kohl van Wijngaarden
Refs #29144 - Correct socket override
28111966587ffd3d283cd8ea76371aed02f568b4 introduced the systemd socket

override, but used Service instead of Socket. This causes the service to
bind incorrectly.

Revision 1e10f6¢c4 - 03/26/2020 12:57 PM - Ewoud Kohl van Wijngaarden
Refs #29144 - Use the correct ListenStream
281f1966587ffd3d283cd8ea76371aed02f568b4 introduced the override with

the incorrect section. e642db1c690cdbc01bfc193b643becel1abb0e91a
corrected the section, but not the headers.

History

#1 - 02/25/2020 04:38 PM - Lukas Zapletal

Nice idea, when this is implemented in Core, let's open the very same ticket for Smart Proxy (once Puma is merged there).

#2 - 03/20/2020 11:52 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Ewoud Kohl van Wijngaarden

- Pull request https://github.com/theforeman/foreman/pull/7536 added

#3 - 03/20/2020 01:34 PM - The Foreman Bot

05/12/2024 2/3



- Pull request https://github.com/theforeman/foreman-packaging/pull/4894 added

#4 - 03/20/2020 01:49 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman-packaging/pull/4895 added

#5 - 03/20/2020 02:55 PM - The Foreman Bot
- Pull request https://github.com/theforeman/puppet-foreman/pull/814 added

#6 - 03/24/2020 12:27 PM - The Foreman Bot
- Fixed in Releases 2.1.0 added

#7 - 03/24/2020 01:01 PM - Ewoud Kohl van Wijngaarden
- Status changed from Ready For Testing to Closed

Applied in changeset 3e38815694272ef06d11efd63ffa29e9c1834c62.

#8 - 03/24/2020 03:28 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman-packaging/pull/4901 added

#9 - 03/26/2020 12:19 AM - The Foreman Bot
- Pull request https://github.com/theforeman/puppet-foreman/pull/816 added

#10 - 03/26/2020 11:39 AM - The Foreman Bot
- Pull request https://github.com/theforeman/puppet-foreman/pull/817 added

#11 - 03/31/2021 09:34 AM - Ewoud Kohl van Wijngaarden
- Related to Feature #32238: Bind systemd socket activation to IPv6 added

#12 - 07/23/2021 04:13 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman-packaging/pull/6944 added

#13 - 07/25/2021 04:09 PM - Ewoud Kohl van Wijngaarden
- Triaged changed from No to Yes

- Pull request deleted (https://github.com/theforeman/foreman-packaging/pull/6944)

#14 - 03/25/2022 04:29 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman-packaging/pull/7748 added

#15 - 03/25/2022 04:40 PM - Ewoud Kohl van Wijngaarden
- Pull request deleted (https://github.com/theforeman/foreman-packaging/pull/7748)
